import {Facet as $hgUW1$Facet, EditorState as $hgUW1$EditorState, StateEffect as $hgUW1$StateEffect} from "@codemirror/state";
import {ViewPlugin as $hgUW1$ViewPlugin, Decoration as $hgUW1$Decoration, WidgetType as $hgUW1$WidgetType, keymap as $hgUW1$keymap, EditorView as $hgUW1$EditorView} from "@codemirror/view";

function $parcel$export(e, n, v, s) {
  Object.defineProperty(e, n, {get: v, set: s, enumerable: true, configurable: true});
}


const $dd612b78dcc23737$export$83c01123c94f86d5 = $hgUW1$Facet.define();
const $dd612b78dcc23737$export$4acf35620932991d = $hgUW1$ViewPlugin.fromClass(class {
    update(update) {
        const tempDecos = [];
        for (const { from: from , to: to  } of update.view.visibleRanges){
            const fromLine = update.view.state.doc.lineAt(from);
            const toLine = update.view.state.doc.lineAt(to);
            for(let lineNumber = fromLine.number; lineNumber <= toLine.number; lineNumber++){
                const line = update.view.state.doc.line(lineNumber);
                const blockMarkerIndex = line.text.indexOf("- ");
                // TODO parse block content
                const regex = /\[\[([^\]]*)\]\]/g;
                let result;
                while((result = regex.exec(line.text)) !== null){
                    let matchIndex = result.index;
                    let t = result[0].length;
                    tempDecos.push($hgUW1$Decoration.mark({
                        inclusive: false,
                        class: "cm-wikilink"
                    }).range(line.from + matchIndex, line.from + matchIndex + t));
                }
            }
        }
        this.decorations = $hgUW1$Decoration.set(tempDecos);
    }
    constructor(){
        this.decorations = $hgUW1$Decoration.none;
    }
}, {
    decorations: (v)=>v.decorations
    ,
    eventHandlers: {
        mousedown: (e, view)=>{
            let target = e.target;
            const line = view.state.doc.lineAt(view.posAtDOM(target));
            // console.log(target.nodeName);
            if (target.classList.contains("cm-wikilink")) console.log("pressed wikilink");
        },
        mousemove: (e, view)=>{
            let target = e.target;
        // const line = view.state.doc.lineAt(view.posAtDOM(target));
        // console.log("mouse move on", line);
        // e.preventDefault();
        },
        dragstart: (e, view)=>{
            let target = e.target;
        // const line = view.state.doc.lineAt(view.posAtDOM(target));
        // console.log("mouse drag", line.number);
        // e.preventDefault();
        },
        drag: (e, view)=>{
            let target = e.target;
        // const line = view.state.doc.lineAt(view.posAtDOM(target));
        // console.log(" drag", line.number);
        // e.preventDefault();
        },
        dragenter: (e, view)=>{
            let target = e.target;
        // const line = view.state.doc.lineAt(view.posAtDOM(target));
        // console.log("enter", line.number);
        // e.preventDefault();
        }
    }
});



var $0d1a5811ad52f858$exports = {};

$parcel$export($0d1a5811ad52f858$exports, "blockMarkerFacet", () => $0d1a5811ad52f858$export$8e922b49b47108a8);

const $0d1a5811ad52f858$export$8e922b49b47108a8 = $hgUW1$Facet.define({
    combine: (values)=>values.length ? values[0] : "- "
});


const $2aadad3bf0192eb6$export$7c81018494681989 = "- ";
function $2aadad3bf0192eb6$export$ae5e9bdaf597fb2b(doc, lineNumber, blockMarker) {
    for(let currentLineNumber = lineNumber; currentLineNumber >= 1; currentLineNumber--){
        const blockLevel = $2aadad3bf0192eb6$export$dc4ba886b3fac467(doc.line(currentLineNumber).text, blockMarker);
        if (blockLevel > 0) return blockLevel;
    }
    return 0;
}
function $2aadad3bf0192eb6$export$74cd7b905dfcd6ed(doc, lineNumber, blockMarker) {
    for(let currentLineNumber = lineNumber; currentLineNumber >= 1; currentLineNumber--){
        const blockLevel = $2aadad3bf0192eb6$export$dc4ba886b3fac467(doc.line(currentLineNumber).text, blockMarker);
        if (blockLevel > 0) return {
            rootBlockLine: currentLineNumber,
            blockLevel: blockLevel
        };
    }
    return {
        rootBlockLine: 0,
        blockLevel: 0
    };
}
function $2aadad3bf0192eb6$export$dc4ba886b3fac467(lineText, blockMarker) {
    // TODO test pattern with start of line
    const index = lineText.indexOf(blockMarker);
    if (index >= 0) return index + 2;
    return 0;
}


const $91dd9522457831d3$export$58aa1f9465c921a9 = $hgUW1$EditorState.transactionFilter.of((transaction)=>{
    const doc = transaction.newDoc;
    const changes = [];
    const blockMarker = transaction.startState.facet($0d1a5811ad52f858$export$8e922b49b47108a8);
    transaction.changes.iterChanges((fromA, toA, fromB, toB, text)=>{
        const fromLine = doc.lineAt(fromA);
        const toLine = doc.lineAt(toB);
        for(let lineNumber = fromLine.number; lineNumber <= toLine.number; lineNumber++){
            const line = doc.line(lineNumber);
            const blockLevelOfLine = $2aadad3bf0192eb6$export$dc4ba886b3fac467(line.text, blockMarker);
            if (blockLevelOfLine <= 0) {
                const shouldBlockLevel = $2aadad3bf0192eb6$export$ae5e9bdaf597fb2b(doc, lineNumber, blockMarker);
                const numOfIndentationSpaces = line.text.length - line.text.trimLeft().length;
                const missingSpaces = shouldBlockLevel - numOfIndentationSpaces - blockMarker.length;
                if (missingSpaces > -blockMarker.length) changes.push({
                    from: line.from,
                    insert: " ".repeat(missingSpaces) + blockMarker
                });
            }
        }
    });
    return [
        transaction,
        {
            changes: changes,
            sequential: true
        }
    ];
});



var $37c0ee7a6bb7f303$exports = {};

$parcel$export($37c0ee7a6bb7f303$exports, "blockLevelChangeEffect", () => $37c0ee7a6bb7f303$export$2840a98950a63cfc);

const $37c0ee7a6bb7f303$export$2840a98950a63cfc = $hgUW1$StateEffect.define();


const $02dd346d5203b0ae$export$77f7ff39ddcfba30 = $hgUW1$Facet.define();
const $02dd346d5203b0ae$export$6b6f53f85b3e253e = $hgUW1$EditorState.transactionFilter.of((transaction)=>{
    let listeners = transaction.startState.facet($02dd346d5203b0ae$export$77f7ff39ddcfba30);
    if (listeners.length) {
        const effects = transaction.effects.filter((effect)=>effect.is($37c0ee7a6bb7f303$export$2840a98950a63cfc)
        ).map((effect)=>effect.value
        );
        listeners.forEach((listenerFn)=>{
            listenerFn(effects);
        });
    }
    return transaction;
});



class $dc924cd4afe4187a$var$DotWidget extends $hgUW1$WidgetType {
    constructor(level){
        super();
        this.level = level;
    }
    eq(other) {
        return other.level == this.level;
    }
    toDOM() {
        const dot = document.createElement("span");
        dot.classList.add("cm-dot");
        const wrap = document.createElement("span");
        wrap.style.paddingRight = `0.7ch`;
        // wrap.style.paddingLeft = `${this.level + 1}ch`;
        wrap.appendChild(dot);
        return wrap;
    }
    ignoreEvent() {
        return false;
    }
}
const $dc924cd4afe4187a$export$ff4ba43d31488064 = $hgUW1$ViewPlugin.fromClass(class {
    update(update) {
        // console.log("updating blocks");
        const tempDecos = [];
        for (const { from: from , to: to  } of update.view.visibleRanges){
            const fromLine = update.view.state.doc.lineAt(from);
            const toLine = update.view.state.doc.lineAt(to);
            for(let lineNumber = fromLine.number; lineNumber <= toLine.number; lineNumber++){
                const line = update.view.state.doc.line(lineNumber);
                const blockMarkerIndex = line.text.indexOf("- ");
                if (blockMarkerIndex >= 0) tempDecos.push($hgUW1$Decoration.replace({
                    widget: new $dc924cd4afe4187a$var$DotWidget(blockMarkerIndex),
                    inclusiveStart: true
                }).range(// line.from,
                line.from + blockMarkerIndex, line.from + blockMarkerIndex + 2));
            }
        }
        this.decorations = $hgUW1$Decoration.set(tempDecos);
    }
    constructor(){
        this.decorations = $hgUW1$Decoration.none;
    }
}, {
    decorations: (v)=>v.decorations
    ,
    eventHandlers: {
        mousedown: (e, view)=>{
            let target = e.target;
            const line = view.state.doc.lineAt(view.posAtDOM(target));
            // console.log(target.nodeName);
            if (target.classList.contains("cm-dot")) {
                console.log("mouse down on", line);
                e.preventDefault();
            }
        },
        mousemove: (e, view)=>{
            let target = e.target;
        // const line = view.state.doc.lineAt(view.posAtDOM(target));
        // console.log("mouse move on", line);
        // e.preventDefault();
        },
        dragstart: (e, view)=>{
            let target = e.target;
        // const line = view.state.doc.lineAt(view.posAtDOM(target));
        // console.log("mouse drag", line.number);
        // e.preventDefault();
        },
        drag: (e, view)=>{
            let target = e.target;
        // const line = view.state.doc.lineAt(view.posAtDOM(target));
        // console.log(" drag", line.number);
        // e.preventDefault();
        },
        dragenter: (e, view)=>{
            let target = e.target;
        // const line = view.state.doc.lineAt(view.posAtDOM(target));
        // console.log("enter", line.number);
        // e.preventDefault();
        }
    }
});






const $82059c613b8c2141$export$ecece46a9d83673b = $hgUW1$Facet.define({
    combine: (values)=>values.length ? values[0] : 2
});



const $cc94730f6934e438$export$c19056918d618803 = $hgUW1$EditorState.transactionFilter.of((transaction)=>{
    const { doc: doc  } = transaction.startState;
    const changes = [];
    const effects = [];
    const indentationPerLevel = transaction.startState.facet($82059c613b8c2141$export$ecece46a9d83673b);
    const blockMarker = transaction.startState.facet($0d1a5811ad52f858$export$8e922b49b47108a8);
    transaction.changes.iterChanges((fromA, toA, fromB, toB, text)=>{
        const fromLine = doc.lineAt(fromA);
        // const toLine = doc.lineAt(toA);
        const fromLevel = $2aadad3bf0192eb6$export$ae5e9bdaf597fb2b(doc, fromLine.number, blockMarker);
        if (fromA === fromLine.from && fromA === toA && text.lines === 1 && !text.line(1).text.trim().length // added only spaces
        ) {
            console.log("level increased");
            effects.push($37c0ee7a6bb7f303$export$2840a98950a63cfc.of({
                fromLevel: Math.floor(fromLevel / indentationPerLevel),
                toLevel: Math.floor((fromLevel + text.line(1).length) / indentationPerLevel),
                // TODO find block root line and set that one
                lineNumber: fromLine.number
            }));
            return transaction;
        }
        const toLevel = toA - fromLine.from;
        if (fromB === toB && text.lines === 1 && toLevel < fromLevel) {
            // whitespace deleted in indentation
            // => level decrease
            console.log(`level decreased from ${fromLevel} to ${toLevel}`);
            effects.push($37c0ee7a6bb7f303$export$2840a98950a63cfc.of({
                // TODO calculate indentation and block level in separate function / component
                fromLevel: Math.floor(fromLevel / indentationPerLevel),
                toLevel: Math.floor(toLevel / indentationPerLevel),
                // TODO find block root line and set that one
                lineNumber: fromLine.number
            }));
            return transaction;
        }
        if (fromA > fromLine.from && fromA - fromLine.from < fromLevel) {
            // delete all levels and merge with previous line
            console.log("deleting line");
            const deleteLineBreakOfPreviousLine = fromLine.number === 1 ? 0 : 1;
            changes.push({
                from: fromLine.from - deleteLineBreakOfPreviousLine,
                to: fromLine.from + fromLevel,
                insert: ""
            });
        }
    });
    return [
        transaction,
        {
            changes: changes,
            effects: effects,
            sequential: false
        }, 
    ];
});





const $a1df0e612eb858f1$export$17c614f2179d51ed = $hgUW1$keymap.of([
    {
        key: "Tab",
        preventDefault: true,
        run: (view)=>$a1df0e612eb858f1$var$_dispatchBlockCommand(view, "increase")
        ,
        shift: (view)=>$a1df0e612eb858f1$var$_dispatchBlockCommand(view, "decrease")
    }, 
]);
function $a1df0e612eb858f1$var$_dispatchBlockCommand(view, mode) {
    const changes = [];
    const lines = view.state.selection.ranges.map((range)=>view.state.doc.lineAt(range.from)
    );
    for (const line of lines){
        if (mode === "increase") {
            console.log("increase");
            changes.push({
                from: line.from,
                insert: "  "
            });
        } else if (mode === "decrease") {
            const blockMarker = view.state.facet($0d1a5811ad52f858$export$8e922b49b47108a8);
            const { rootBlockLine: rootBlockLine , blockLevel: blockLevel  } = $2aadad3bf0192eb6$export$74cd7b905dfcd6ed(view.state.doc, line.number, blockMarker);
            if (rootBlockLine && blockLevel - 2 > 0) {
                console.log(`decrease rootBlockLine=${rootBlockLine}, blockLevel=${blockLevel}`);
                changes.push({
                    from: line.from,
                    to: line.from + 2
                });
            }
        } else throw new Error("Unhandled mode: " + mode);
    }
    if (!changes.length) return false;
    view.dispatch({
        changes: changes
    });
    return true;
}



const $b02de4dcc23bda64$export$9569bcad5c542089 = $hgUW1$EditorView.baseTheme({
    ".cm-dot": {
        height: "1.3ch",
        width: "1.3ch",
        backgroundColor: "#bbb",
        borderRadius: "50%",
        display: "inline-block",
        cursor: "grab"
    },
    ".cm-dot:hover": {
        backgroundColor: "#000"
    },
    ".cm-wikilink": {
        color: "#AA5555",
        cursor: "pointer"
    }
});





const $a6aea703f0198572$export$e118f6712799d2ce = $hgUW1$EditorState.transactionFilter.of((transaction)=>{
    const doc = transaction.newDoc;
    let selectionChange = undefined;
    const blockMarker = transaction.startState.facet($0d1a5811ad52f858$export$8e922b49b47108a8);
    for (const { head: head , anchor: anchor  } of transaction.newSelection.ranges){
        const headLine = doc.lineAt(head);
        const headBlockLevel = $2aadad3bf0192eb6$export$ae5e9bdaf597fb2b(doc, headLine.number, blockMarker);
        const headBlockEndIndex = headLine.from + headBlockLevel;
        const anchorLine = doc.lineAt(anchor);
        const anchorBlockLevel = $2aadad3bf0192eb6$export$ae5e9bdaf597fb2b(doc, anchorLine.number, blockMarker);
        const anchorBlockEndIndex = anchorLine.from + anchorBlockLevel;
        let newHead = head;
        let newAnchor = anchor;
        if (head <= headBlockEndIndex) newHead = headBlockEndIndex;
        if (anchor <= anchorBlockEndIndex) newAnchor = anchorBlockEndIndex;
        if (newHead !== head || newAnchor !== anchor) selectionChange = {
            anchor: newAnchor,
            head: newHead
        };
    }
    return [
        transaction,
        {
            selection: selectionChange,
            sequential: true
        }
    ];
});


function $23570ec154cdbc31$export$af91ca1d97b3a675(_options = {
}) {
    return [
        // TODO there is a bug that changes precedence -> have to change order of extensions with that patch
        // views
        $dd612b78dcc23737$export$4acf35620932991d,
        $dc924cd4afe4187a$export$ff4ba43d31488064,
        $b02de4dcc23bda64$export$9569bcad5c542089,
        // listeners
        $02dd346d5203b0ae$export$6b6f53f85b3e253e,
        // selection
        $a6aea703f0198572$export$e118f6712799d2ce,
        // changes
        $91dd9522457831d3$export$58aa1f9465c921a9,
        $cc94730f6934e438$export$c19056918d618803,
        // keymap
        $a1df0e612eb858f1$export$17c614f2179d51ed, 
    ];
}





var $a2d68d7b28d7117d$exports = {};

$parcel$export($a2d68d7b28d7117d$exports, "version", () => $a2d68d7b28d7117d$export$83d89fbfd8236492);
const $a2d68d7b28d7117d$export$83d89fbfd8236492 = '0.8.0';




export {$23570ec154cdbc31$export$af91ca1d97b3a675 as blockEditor, $02dd346d5203b0ae$export$77f7ff39ddcfba30 as blockLevelListenerFacet, $37c0ee7a6bb7f303$export$2840a98950a63cfc as blockLevelChangeEffect, $0d1a5811ad52f858$export$8e922b49b47108a8 as blockMarkerFacet, $a2d68d7b28d7117d$export$83d89fbfd8236492 as version};
//# sourceMappingURL=index.js.map
